/******************************************************************************
 * File Name   : MX_Device.h
 * Date        : 20/09/2022 14:55:53
 * Description : STM32Cube MX parameter definitions
 * Note        : This file is generated by STM32CubeMX (DO NOT EDIT!)
 ******************************************************************************/

#ifndef __MX_DEVICE_H
#define __MX_DEVICE_H

/*---------------------------- Clock Configuration ---------------------------*/

#define MX_LSI_VALUE                            32000
#define MX_LSE_VALUE                            32768
#define MX_HSI_VALUE                            48000000
#define MX_HSE_VALUE                            8000000
#define MX_AHBFreq_Value                        48000000
#define MX_APBFreq_Value                        48000000
#define MX_HCLKFreq_Value                       48000000
#define MX_CortexFreq_Value                     48000000
#define MX_SYSCLKFreq_VALUE                     48000000
#define MX_ADCFreq_Value                        48000000
#define MX_APBTimFreq_Value                     48000000
#define MX_I2C1Freq_Value                       48000000
#define MX_I2S1Freq_Value                       48000000
#define MX_FCLKCortexFreq_Value                 48000000
#define MX_RTCFreq_Value                        32000
#define MX_PWRFreq_Value                        48000000
#define MX_MCO1PinFreq_Value                    48000000
#define MX_EXTERNAL_CLOCK_VALUE                 12288000
#define MX_USART1Freq_Value                     48000000
#define MX_WatchDogFreq_Value                   32000

/*-------------------------------- ADC1       --------------------------------*/

#define MX_ADC1                                 1

/* GPIO Configuration */

/* Pin PA8 */
#define MX_ADC1_IN8_Pin                         PA8
#define MX_ADC1_IN8_GPIOx                       GPIOA
#define MX_ADC1_IN8_GPIO_PuPd                   GPIO_NOPULL
#define MX_ADC1_IN8_GPIO_Pin                    GPIO_PIN_8
#define MX_ADC1_IN8_pin_binding                 __NULL
#define MX_ADC1_IN8_GPIO_Mode                   GPIO_MODE_ANALOG

/*-------------------------------- CORTEX_M0+ --------------------------------*/

#define MX_CORTEX_M0+                           1

/*-------------------------------- SPI1       --------------------------------*/

#define MX_SPI1                                 1

/* GPIO Configuration */

/* Pin PA4 */
#define MX_SPI1_NSS_GPIO_Speed                  GPIO_SPEED_FREQ_LOW
#define MX_SPI1_NSS_Pin                         PA4
#define MX_SPI1_NSS_GPIOx                       GPIOA
#define MX_SPI1_NSS_PinState                    GPIO_PIN_RESET
#define MX_SPI1_NSS_GPIO_PuPd                   GPIO_NOPULL
#define MX_SPI1_NSS_GPIO_Pin                    GPIO_PIN_4
#define MX_SPI1_NSS_pin_binding                 __NULL
#define MX_SPI1_NSS_GPIO_AF                     GPIO_AF0_SPI1
#define MX_SPI1_NSS_GPIO_Mode                   GPIO_MODE_AF_PP

/* Pin PA6 */
#define MX_SPI1_MISO_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_SPI1_MISO_Pin                        PA6
#define MX_SPI1_MISO_GPIOx                      GPIOA
#define MX_SPI1_MISO_PinState                   GPIO_PIN_RESET
#define MX_SPI1_MISO_GPIO_PuPd                  GPIO_NOPULL
#define MX_SPI1_MISO_GPIO_Pin                   GPIO_PIN_6
#define MX_SPI1_MISO_pin_binding                __NULL
#define MX_SPI1_MISO_GPIO_AF                    GPIO_AF0_SPI1
#define MX_SPI1_MISO_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PA7 */
#define MX_SPI1_MOSI_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_SPI1_MOSI_Pin                        PA7
#define MX_SPI1_MOSI_GPIOx                      GPIOA
#define MX_SPI1_MOSI_PinState                   GPIO_PIN_RESET
#define MX_SPI1_MOSI_GPIO_PuPd                  GPIO_NOPULL
#define MX_SPI1_MOSI_GPIO_Pin                   GPIO_PIN_7
#define MX_SPI1_MOSI_pin_binding                __NULL
#define MX_SPI1_MOSI_GPIO_AF                    GPIO_AF0_SPI1
#define MX_SPI1_MOSI_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PA5 */
#define MX_SPI1_SCK_GPIO_Speed                  GPIO_SPEED_FREQ_LOW
#define MX_SPI1_SCK_Pin                         PA5
#define MX_SPI1_SCK_GPIOx                       GPIOA
#define MX_SPI1_SCK_PinState                    GPIO_PIN_RESET
#define MX_SPI1_SCK_GPIO_PuPd                   GPIO_NOPULL
#define MX_SPI1_SCK_GPIO_Pin                    GPIO_PIN_5
#define MX_SPI1_SCK_pin_binding                 __NULL
#define MX_SPI1_SCK_GPIO_AF                     GPIO_AF0_SPI1
#define MX_SPI1_SCK_GPIO_Mode                   GPIO_MODE_AF_PP

/*-------------------------------- SYS        --------------------------------*/

#define MX_SYS                                  1

/*-------------------------------- USART1     --------------------------------*/

#define MX_USART1                               1

#define MX_USART1_VM                            VM_ASYNC

/* GPIO Configuration */

/* Pin PA9 [PA11] */
#define MX_USART1_TX_GPIO_ModeDefaultPP         GPIO_MODE_AF_PP
#define MX_USART1_TX_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_USART1_TX_Pin                        PA9_PA11
#define MX_USART1_TX_GPIOx                      GPIOA
#define MX_USART1_TX_GPIO_PuPd                  GPIO_NOPULL
#define MX_USART1_TX_GPIO_Pin                   GPIO_PIN_9
#define MX_USART1_TX_pin_binding                __NULL
#define MX_USART1_TX_GPIO_AF                    GPIO_AF1_USART1
#define MX_USART1_TX_GPIO_FMPA9                 __NULL

/* Pin PA10 [PA12] */
#define MX_USART1_RX_GPIO_FMPA10                __NULL
#define MX_USART1_RX_GPIO_ModeDefaultPP         GPIO_MODE_AF_PP
#define MX_USART1_RX_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_USART1_RX_Pin                        PA10_PA12
#define MX_USART1_RX_GPIOx                      GPIOA
#define MX_USART1_RX_GPIO_PuPd                  GPIO_NOPULL
#define MX_USART1_RX_GPIO_Pin                   GPIO_PIN_10
#define MX_USART1_RX_pin_binding                __NULL
#define MX_USART1_RX_GPIO_AF                    GPIO_AF1_USART1

/*-------------------------------- USART2     --------------------------------*/

#define MX_USART2                               1

#define MX_USART2_VM                            VM_ASYNC

/* GPIO Configuration */

/* Pin PA2 */
#define MX_USART2_TX_GPIO_ModeDefaultPP         GPIO_MODE_AF_PP
#define MX_USART2_TX_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_USART2_TX_Pin                        PA2
#define MX_USART2_TX_GPIOx                      GPIOA
#define MX_USART2_TX_PinState                   GPIO_PIN_RESET
#define MX_USART2_TX_GPIO_PuPd                  GPIO_NOPULL
#define MX_USART2_TX_GPIO_Pin                   GPIO_PIN_2
#define MX_USART2_TX_pin_binding                __NULL
#define MX_USART2_TX_GPIO_AF                    GPIO_AF1_USART2

/* Pin PA3 */
#define MX_USART2_RX_GPIO_ModeDefaultPP         GPIO_MODE_AF_PP
#define MX_USART2_RX_GPIO_Speed                 GPIO_SPEED_FREQ_LOW
#define MX_USART2_RX_Pin                        PA3
#define MX_USART2_RX_GPIOx                      GPIOA
#define MX_USART2_RX_PinState                   GPIO_PIN_RESET
#define MX_USART2_RX_GPIO_PuPd                  GPIO_NOPULL
#define MX_USART2_RX_GPIO_Pin                   GPIO_PIN_3
#define MX_USART2_RX_pin_binding                __NULL
#define MX_USART2_RX_GPIO_AF                    GPIO_AF1_USART2

/*-------------------------------- NVIC       --------------------------------*/

#define MX_NVIC                                 1

/*-------------------------------- GPIO       --------------------------------*/

#define MX_GPIO                                 1

/* GPIO Configuration */

/* Pin PF2-NRST */
#define MX_PF2_NRST_Pin                         PF2_NRST
#define MX_PF2_NRST_GPIOx                       GPIOF
#define MX_PF2_NRST_GPIO_PuPd                   GPIO_NOPULL
#define MX_PF2_NRST_GPIO_Pin                    GPIO_PIN_2
#define MX_PF2_NRST_pin_binding                 __NULL
#define MX_PF2_NRST_GPIO_Mode                   GPIO_MODE_INPUT

/* Pin PB6 */
#define MX_PB6_GPIO_Speed                       GPIO_SPEED_FREQ_VERY_HIGH
#define MX_PB6_GPIO_FM6                         __NULL
#define MX_PB6_Pin                              PB6
#define MX_PB6_GPIOx                            GPIOB
#define MX_PB6_PinState                         GPIO_PIN_SET
#define MX_PB6_GPIO_PuPd                        GPIO_NOPULL
#define MX_PB6_GPIO_Pin                         GPIO_PIN_6
#define MX_PB6_pin_binding                      __NULL
#define MX_PB6_GPIO_ModeDefaultOutputPP         GPIO_MODE_OUTPUT_PP

#endif  /* __MX_DEVICE_H */

