[#ftl]
[#list configs as dt]
[#assign data = dt]
[#assign peripheralParams = dt.peripheralParams]
[#assign peripheralGPIOParams = dt.peripheralGPIOParams]
[#assign peripheralDMAParams = dt.peripheralDMAParams]
[#assign peripheralNVICParams = dt.peripheralNVICParams]
[#assign usedIPs = dt.usedIPs]
[#assign adc_hal=false adc_ll=false]
[#assign dma_hal=false dma_ll=false]
[#assign gpio_hal=false gpio_ll=false]
[#assign i2c_hal=false i2c_ll=false smbus_hal=false]
[#assign i2s_hal=false]
[#assign irda_hal=false]
[#assign tim_hal=false tim_ll=false] 
[#assign spi_hal=false spi_ll=false] 
[#assign usart_hal=false usart_ll=false uart_hal=false smartcard_hal=false]
[#assign timebase_tim = false]
[#if timeBaseSource?? && timeBaseSource!="SysTick"]
[#assign timebase_tim = true]
[/#if]
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!-- ******************************************************************************
 * File Name   : FrameworkCubeMX.gpdsc
 * Date        : ${date}
 * Description : Generator PDSC File generated by STM32CubeMX (DO NOT EDIT!)
 ****************************************************************************** -->

<package xmlns:xs="http://www.w3.org/2001/XMLSchema-instance" schemaVersion="1.0" xs:noNamespaceSchemaLocation="PACK.xsd">
  <vendor>Keil</vendor>
  <name>FrameworkCubeMX</name>
  <description>STM32CubeMX generated pack description</description>
  <url>project-path</url>
  <releases>
    <release version="1.0.0">
     - Generated: ${date}
    </release>
  </releases>
  <generators>
    <generator id="STM32CubeMX" Gvendor="STMicroelectronics" Gtool="STM32CubeMX" Gversion="6.4.0">
      <description>STM32CubeMX Environment</description>
      <select Dname="${(dt.device)}" Dvendor="STMicroelectronics:13"/>
      <command>$SMDK\CubeMX\STM32CubeMXLauncher</command>
      <workingDir>$PRTE\Device\${(dt.device)}</workingDir>
      <project_files>
        <file category="include" name="STCubeGenerated/Inc/"/>
        <file category="source" name="STCubeGenerated/Src/main.c" />
        <file category="header" name="STCubeGenerated/Inc/stm32c0xx_it.h"/>
        <file category="source" name="STCubeGenerated/Src/stm32c0xx_it.c"/>
      </project_files>
    </generator>
  </generators>
  <taxonomy>
    <description Cclass="Device" Cgroup="STM32Cube Framework" generator="STM32CubeMX">STM32Cube Framework</description>
  </taxonomy>
  <conditions>
    <condition id="STCubeMX">
      <description>Condition to include CMSIS core, Device Startup and HAL Drivers components</description>
      <require Dvendor="STMicroelectronics:13" Dname="STM32C0*"/>
      <require Cclass="CMSIS"  Cgroup="CORE"          Csub=""/>
      <require Cclass="Device" Cgroup="Startup"/>
      [#if peripheralParams.get("RCC")??]
      [#if peripheralParams.get("RCC").get("driver") == ("HAL")]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="Common"/>
      [#else]
      <require Cclass="Device" Cgroup="STM32Cube LL" Csub="Common"/>
      [/#if]
      [/#if]
[#list usedIPs as ip]
[#if peripheralDMAParams.get(ip)?? && peripheralDMAParams.get(ip).entrySet()?size > 0]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !dma_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="DMA"/>
      [#assign dma_hal=true]
      [/#if]        
    [#elseif !dma_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="DMA"/>
      [#assign dma_ll=true]
    [/#if]
[/#if]
[#if peripheralGPIOParams.get(ip)?? && peripheralGPIOParams.get(ip).entrySet()?size > 0]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !gpio_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="GPIO"/>
      [#assign gpio_hal=true]
      [/#if]        
    [#elseif !gpio_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="GPIO"/>
      [#assign gpio_ll=true]
    [/#if]
[/#if]
[#if peripheralParams.get(ip)??]
[#if ip?starts_with("ADC")]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !adc_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="ADC"/>
      [#assign adc_hal=true]
      [/#if]
    [#elseif !adc_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="ADC"/>
      [#assign adc_ll=true]
    [/#if]
[#elseif ip?starts_with("CORTEX")]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="Cortex"/>
[#elseif ip?starts_with("CRC")]
  [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="CRC"/>
  [#else]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="CRC"/>
  [/#if]
[#elseif ip?starts_with("DMA")]
  [#if peripheralParams.get(ip).get("driver") == ("HAL")]
    [#if !dma_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="DMA"/>
      [#assign dma_hal=true]
    [/#if]        
  [#elseif !dma_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="DMA"/>
      [#assign dma_ll=true]
  [/#if]
[#elseif ip?starts_with("GPIO")]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !gpio_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="GPIO"/>
      [#assign gpio_hal=true]
      [/#if]        
    [#elseif !gpio_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="GPIO"/>
      [#assign gpio_ll=true]
    [/#if]
[#elseif ip?starts_with("I2C")]
    [#assign smbus=false]
    [#list peripheralParams.get(ip).entrySet() as paramEntry]
    [#if paramEntry.key?starts_with("SMBusOwnAddress")]
      [#assign smbus=true]
    [/#if]
    [/#list]    
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !i2c_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="I2C"/>
      [#assign i2c_hal=true]
      [/#if]        
    [#elseif !i2c_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="I2C"/>
      [#assign i2c_ll=true]        
    [/#if]
    [#if smbus == true]
      [#if !smbus_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="SMBUS"/>
      [#assign smbus_hal=true]
      [/#if]        
    [/#if]    
[#elseif ip?starts_with("I2S")]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !i2s_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="I2S"/>
      [#assign i2s_hal=true]
      [/#if]        
    [/#if]    
[#elseif ip == "NVIC"]
[#elseif ip?starts_with("SPI")]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !spi_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="SPI"/>
      [#assign spi_hal=true]
      [/#if]        
    [#elseif !spi_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="SPI"/>
      [#assign spi_ll=true]        
    [/#if]
[#elseif ip?starts_with("SYS")]
[#elseif ip?starts_with("TIM")]
    [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      [#if !tim_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="TIM"/>
      [#assign tim_hal=true]
      [/#if]        
    [#elseif !tim_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="TIM"/>
      [#assign tim_ll=true]        
    [/#if]
[#elseif ip?starts_with("UART")]
  [#if peripheralParams.get(ip).get("driver") == ("HAL")]
    [#list peripheralParams.get(ip).entrySet() as paramEntry]
    [#if paramEntry.key?starts_with("Mode")]  
      [#if paramEntry.value?starts_with("IRDA")]
      [#if !irda_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="IRDA"/>
      [#assign irda_hal=true]
      [/#if]
      [#else]
      [#if !uart_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="UART"/>
      [#assign uart_hal=true]
      [/#if]
      [/#if]
    [/#if]
    [/#list]
  [#else]
      [#if !usart_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL" Csub="USART"/>
      [#assign usart_ll=true]
      [/#if]
  [/#if]  
[#elseif ip?starts_with("USART")]
  [#if peripheralParams.get(ip).get("driver") == ("HAL")]
    [#list peripheralParams.get(ip).entrySet() as paramEntry]  
    [#if paramEntry.key?starts_with("VirtualMode")]
      [#if paramEntry.value == "VM_IRDA"]
      [#if !irda_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="IRDA"/>
      [#assign irda_hal=true]
      [/#if]
      [#elseif paramEntry.value == "VM_SMARTCARD"]
      [#if !smartcard_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="Smartcard"/>
      [#assign smartcard_hal=true]
      [/#if]
      [#elseif paramEntry.value == "VM_SYNC"]
      [#if !usart_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="USART"/>
      [#assign usart_hal=true]
      [/#if]
      [#else]
      [#if !uart_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="UART"/>
      [#assign uart_hal=true]
      [/#if]
      [/#if]
    [/#if]
    [/#list]
  [#else]
      [#if !usart_ll]
      <require Cclass="Device" Cgroup="STM32Cube LL" Csub="USART"/>
      [#assign usart_ll=true]
      [/#if]
  [/#if]  
[#elseif ip?starts_with("DEBUG")]
[#elseif ip?starts_with("TAMP")]
[#elseif ip?starts_with("VREFBUF")]
[#else]
      [#if peripheralParams.get(ip).get("driver") == ("HAL")]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="${(ip)}"/>
      [#else]
      <require Cclass="Device" Cgroup="STM32Cube LL"  Csub="${(ip)}"/>
      [/#if]
[/#if]
[/#if]
[/#list]
[#if timebase_tim == true]
  [#if !tim_hal]
      <require Cclass="Device" Cgroup="STM32Cube HAL" Csub="TIM"/>
      [#assign tim_hal=true]
  [/#if]
[/#if]
    </condition>
  </conditions>
  <components>
    <component generator="STM32CubeMX" Cvendor="Keil" Cclass="Device" Cgroup="STM32Cube Framework" Csub="STM32CubeMX" Cversion="1.1.0" condition="STCubeMX">
      <description>Configuration via STM32CubeMX</description>
      <RTE_Components_h>
        #define RTE_DEVICE_FRAMEWORK_CUBE_MX
      </RTE_Components_h>
      <files>
        <file category="header" name="MX_Device.h"/>
        <file category="header" name="STCubeGenerated/Inc/stm32c0xx_hal_conf.h"/>
[#if peripheralParams.get("RCC")??]
[#if peripheralParams.get("RCC").get("driver") == ("HAL")]
        <file category="source" name="STCubeGenerated/Src/stm32c0xx_hal_msp.c"/>
[/#if]
[/#if]
[#if timebase_tim == true]
        <file category="source" name="STCubeGenerated/Src/stm32c0xx_hal_timebase_tim.c"/>
[/#if]
      </files>
    </component>
  </components>
</package>
[/#list]
