# STM32CubeC0 MCU Firmware Package

**STM32Cube** is an STMicroelectronics original initiative to ease the developers life by reducing efforts, time and cost.

**STM32Cube** covers the overall STM32 products portfolio. It includes a comprehensive embedded software platform (this repo), delivered for each series (such as the STM32CubeC0 for the STM32C0 series).
   * The CMSIS modules (core and device) corresponding to the ARM tm core implemented in this STM32 product
   * The STM32 HAL-LL drivers : an abstraction drivers layer, the API ensuring maximized portability across the STM32 portfolio 
   * The BSP Drivers of each evaluation or demonstration board provided by this STM32 series 
   * A consistent set of middlewares components such as ThreadX,FileX and OpenBootloader.
   * A full set of software projects (basic examples and applications ) for each board provided by this STM32 series
   * A development with three Toolchains and Compilers (IAR Embedded Workbench for ARM (EWARM), RealView Microcontroller Development Kit (MDK-ARM), and STM32CubeIDE).

The **STM32CubeC0 MCU Package** projects are directly running on the STM32C0 series boards. You can find in each Projects/*Board name* directories a set of software projects (Applications/Demonstration/Examples)


## Release note
Details about the content of this release are available in the release note

## Boards available
  * STM32C0 Boards
    * [STM32C0316-DK] 
    * [NUCLEO-C031C6] 
    * [STM32C0116-DK] 
